/*

Copyright (c) 2019 Texas Instruments Incorporated

All rights reserved not granted herein.

Limited License.  

Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive license under copyrights and patents it now or hereafter owns or controls to make, have made, use, import, offer to sell and sell ("Utilize") this software subject to the terms herein.  With respect to the foregoing patent license, such license is granted  solely to the extent that any such patent is necessary to Utilize the software alone.  The patent license shall not apply to any combinations which include this software, other than combinations with devices manufactured by or for TI (“TI Devices”).  No hardware patent is licensed hereunder.

Redistributions must preserve existing copyright notices and reproduce this license (including the above copyright notice and the disclaimer and (if applicable) source code license limitations below) in the documentation and/or other materials provided with the distribution

Redistribution and use in binary form, without modification, are permitted provided that the following conditions are met:

*	No reverse engineering, decompilation, or disassembly of this software is permitted with respect to any software provided in binary form.

*	any redistribution and use are licensed by TI for use only with TI Devices.

*	Nothing shall obligate TI to provide you with source code for the software licensed and provided to you in object code.

If software source code is provided to you, modification and redistribution of the source code are permitted provided that the following conditions are met:

*	any redistribution and use of the source code, including any resulting derivative works, are licensed by TI for use only with TI Devices.

*	any redistribution and use of any object code compiled from the source code and any resulting derivative works, are licensed by TI for use only with TI Devices.

Neither the name of Texas Instruments Incorporated nor the names of its suppliers may be used to endorse or promote products derived from this software without specific prior written permission.

DISCLAIMER.

THIS SOFTWARE IS PROVIDED BY TI AND TI’S LICENSORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TI’S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

var chart;
var timerD = null;
var total = 0;
var plotCounter = 0;
var numSamples = 256;
var sampleArray = [numSamples];
var sampleMin = 0;
var sampleMax = 0;
var sampleMean = 0;
var voltageMean = 0;
var voltageP2P = 0;
var voltageSTD = 0;
var codeMean = 0;
var codeP2P = 0;
var codeSTD = 0;
var sampleP2P = 0;
var sampleSTD = 0;
var gain = 1;
var convertMode = 0;
var bConvert = false;

var extendAboutBox = function() {
    var aboutBox = document.querySelector('ti-widget-aboutbox');
    if (aboutBox){
        aboutBox.addEventListener('aboutbox_opening', function(event){
            aboutBox.appInfoTextHeading = 'Details';
            aboutBox.softwareManifestLink = "app/docs/ADS1119_BoosterPack_GUI_1.0.0_manifest.html";
            var str = '***************************\nADS1119 BoosterPack GUI\n****************************\n';
            str = str + 'Version                 : ';
            str = str + 'Publish Date            : 01/23/2019\n';
            str = str + 'ADS1119 Revision 1.0.0\n';
            str = str + '\n';
            str = str + 'Change List\n';
            str = str + '  01/23/2019: Initial Release\n';
            str = str + '\n';
            str = str + '******************************\nConnected device\n******************************\n';
            aboutBox.appInfoText = str + 'Retreiving version information ...\nPlease connect hardware';
            aboutBox.numRowsInAppInfoTextArea = 16;
        });
    }
};

/*
 *  Boilerplate code for creating computed data bindings
 */
document.addEventListener('gc-databind-ready', function() {
    /*
     *   Add custom computed value databindings here, using the following method:
     *
     *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
     *
     *   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
     *   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
     */

    // For example, a simple computed values based on simple expression
    // gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");

    // Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
    // gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });

    // Event 1 to n bindings
    /*
    gc.databind.registry.bind('widget.date.value',
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        },
        // getter for date computation
        function(values)
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    );
	*/
	extendAboutBox();
});

/*
 *  Boilerplate code for creating custom actions
 */
document.addEventListener('gc-nav-ready', function() {
    /*
     *   Add custom actions for menu items using the following api:
     *
     *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
     *
     *   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
     *   param runable - function that performs the custom action.
     *   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
     *   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
     */

    // For example,
    // gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });

    // Alternatively, to programmatically disable a menu action at any time use:
    // gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction');

    gc.nav.registerAction('show_introduction', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 0;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 1;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_motor_control', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('load_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            gc.File.browseAndLoad(null, {
                bin: false
            }, function(contents, properties) {
                var regData = null;
                try {
                    regData = JSON.parse(contents);
                    if (regData) {
                        templateObj.setRegisterData(regData);
                        templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
                    }
                } catch (ex) {
                    templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
                }

            });
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    var saveText = function(fname, text, mime) {
        var blob = new Blob([text], {
            type: mime
        });
        saveAs(blob, fname);
        return false;
    };
    gc.nav.registerAction('save_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            var regData = templateObj.getRegisterData();
            var regDataJson = JSON.stringify(regData);
            if (gc.desktop.isDesktop()) {
                gc.File.browseAndSave(regDataJson, 'regs.json', '*.json', function(result, errorInfo) {
                    if (errorInfo) {
                        templateObj.logMsgAndNotify("error", "Save Registers: " + errorInfo, false, true);
                    } else if ((result) && (result.localPath)) {
                        templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: saved to " + result.localPath);
                    }

                });
            } else {
                saveText("regs.json", regDataJson, 'text/plain;charset=utf-8');
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: regs.json file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('save_registers_as', function() {
        if ((templateObj) && (templateObj.$)) {
            var regData = templateObj.getRegisterData();
            var regDataJson = JSON.stringify(regData);
            if (gc.desktop.isDesktop()) {
                gc.File.browseAndSave(regDataJson, 'regs.json', '*.json', function(result, errorInfo) {
                    if (errorInfo) {
                        templateObj.logMsgAndNotify("error", "Save Registers As: " + errorInfo, false, true);
                    } else if ((result) && (result.localPath)) {
                        templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers As: saved to " + result.localPath);
                    }
                });
            } else {
                saveText("regs.json", regDataJson, 'text/plain;charset=utf-8');
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: regs.json file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    
    gc.nav.registerAction('save_data_as', function() {
        if ((templateObj) && (templateObj.$)) {
            
            var regDataRow = sampleArray.toString();
            var regData = regDataRow.replace(/,/g,"\r\n");
            
            
            
            if (gc.desktop.isDesktop()) {
                gc.File.browseAndSave(regData, 'data.txt', '*.txt', function(result, errorInfo) {
                    if (errorInfo) {
                        templateObj.logMsgAndNotify("error", "Save Data As: " + errorInfo, false, true);
                    } else if ((result) && (result.localPath)) {
                        templateObj.$.ti_widget_eventlog_view.log("info", "Save Data As: saved to " + result.localPath);
                    }
                });
            } else {
                saveText("data.txt", regData, 'text/plain;charset=utf-8');
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Data: data.txt file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_log_pane', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_eventlog_view.openView();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

});

/*
 *  Boilerplate code for working with components in the application gist
 */


var initComplete = false;
var templateObj;
var registerModel;
var chartValue = 1;
var refVoltage = 2.048;
var LSBsize = refVoltage / (Math.pow(2,15));

//////
function getData() {

        if (total === 0) {
            sampleArray.length = 0;
            plotCounter = 0;
        }
            chart.series_0_values = sampleArray;
            chart.plotCounter = plotCounter;
            chart.updateGraph();
    }

function onChartReady() {
        
        
        chart.redrawOnOptionsChange = true;
        chart.redrawOnValuesChange = true;
        


    }
//////



// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
    templateObj.addEventListener('dom-change', function() {
        if (initComplete) return;
        this.async(function() {
            initComplete = true;
            console.log("Application template has been stamped.");
            templateObj.$.ti_widget_toast.hideToast();
            templateObj.$.ti_widget_eventlog_view.log("info", "Application started.");
            registerModel = Polymer.dom(document).querySelector('ti-model-register');
            if (registerModel) {
                registerModel.addEventListener("usbHidModelReceivingData", function (event) {
                    templateObj.logMsgAndNotify("debug", "Receiving data from target.", false, false);
                });
            } else {
                console.log("no ti-model-register component found in this application!");
            }
            /* This is a test for checking the transfer of data to the interrupt callback */
            gc.databind.registry.getBinding("reg.aevm.gpio.INT").addChangedListener({
                onValueChanged: function(oldValue,newValue) { 
                var mycodec = templateObj.$.my_model.getCodec();
                var interfaces = mycodec.getInterfaces();
                var i2c = interfaces.i2c;
                console.log('hit');
                
                if(newValue){
                    console.log(newValue);
                    var numValue = (newValue[0]<<8) + newValue[1];
                    if (numValue> 32767) numValue = (numValue - 65536); 
                   
                    if(chartValue===1) {
                        numValue = numValue * LSBsize / gain;
                        
                    }
                    console.log(numValue);
                    
                    if(numSamples < sampleArray.push(numValue)) console.log("too many samples");
                    total +=1;
                    // update binding widget value
                    templateObj.$.ti_widget_textbox.setText(total);
                    plotCounter++;
                    if(convertMode===0 && bConvert) i2c.I2C_Write(2,0x40,[8]);
                }
                }
            });
            // chart stuff
            chart = templateObj.$.ti_widget_linegraph;
            
            chart.addEventListener("graphReady", onChartReady, false);


            // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
            // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId

            // open the eventlog viewer when the user clicks on the book icon in the status bar:
            templateObj.$.ti_widget_eventlog_view.closeView(); // ensure that view states are in sync with application
            templateObj.$.ti_widget_statusbar.addEventListener("appiconclicked", function(event) {
                templateObj.$.ti_widget_eventlog_view.toggleView();
            });

            /* This is a test to verify respone of toggle button */
            // When using GPIO to reset, communication is broken unless a register write is issued before the next read
            // Consider using RESET command.....This should also be a toggle function in GPIO
            templateObj.$.ti_widget_toggle_button1.addEventListener('click', function(event) {
                var detailsObj = event.currentTarget;
                var mycodec = templateObj.$.my_model.getCodec();
                var interfaces = mycodec.getInterfaces();
                var gpio = interfaces.gpio;
                if(detailsObj.__data__.checked=== true){
                    console.log('true button press');
                    gpio.GPIO_Write(2,0x40, 0x40);
                }
                else {
                    console.log('false button press');
                    gpio.GPIO_Write(2,0x40, 0x00);
                }
                
            });
            
            
            templateObj.$.ti_widget_button.addEventListener('click', function(event) {
                var detailsObj = event.currentTarget;
                var mycodec = templateObj.$.my_model.getCodec();
                var interfaces = mycodec.getInterfaces();
                var i2c = interfaces.i2c;
                
                if(detailsObj.__data__.label==="START") {
                    console.log('true button press');
                    i2c.I2C_Write(2,0x40,[8]);
                    bConvert = true;
                    templateObj.$.ti_widget_button.label = "STOP";
                    templateObj.$.ti_widget_textbox3.setText(0);
                    templateObj.$.ti_widget_textbox4.setText(0);
                    templateObj.$.ti_widget_textbox5.setText(0);
                    templateObj.$.ti_widget_textbox6.setText(0);
                    templateObj.$.ti_widget_textbox7.setText(0);
                        total = 0;
                        plotCounter = 0;
                        sampleArray.length = 0;
                        chart.plotCounter = plotCounter;
                        if (timerD===null) timerD = setInterval(getData, 500);
                   
                }
                else {
                    console.log('false button press');
                    bConvert = false;
                    i2c.I2C_Write(2,0x40,[2]);
                    templateObj.$.ti_widget_button.label = "START";
                    sampleMean = 0;
                    voltageMean = 0;
                    voltageP2P = 0;
                    voltageSTD = 0;
                    codeMean = 0;
                    codeP2P = 0;
                    codeSTD = 0;
                    sampleP2P = 0;
                    sampleSTD = 0;
                    sampleMax = 0;
                    sampleMin = 0;

                    var devMean = 0;
                    
                    // if the chart is displaying voltage we need to convert to codes
                    // the code section below will change the sampleArray value so if voltage was to be displayed
                    // the wrong data will show up so calculations need to be something different in this case
                    if(chartValue===1) {
                        sampleMax = -32768*LSBsize/gain;
                        sampleMin = 32768*LSBsize/gain;
                        for(i=0;i<plotCounter;i++){
                            sampleMean += sampleArray[i];
                            if(sampleMax<(sampleArray[i])) sampleMax = sampleArray[i];
                            if(sampleMin>(sampleArray[i])) sampleMin = sampleArray[i];
                        }
                        sampleMean = sampleMean/plotCounter;
                        for(i=0;i<plotCounter;i++){
                            sampleSTD += Math.pow(((sampleArray[i]) - sampleMean),2);
                        }
                        voltageP2P = (sampleMax - sampleMin);
                        sampleP2P = voltageP2P;
                        voltageMean = sampleMean;
                        sampleSTD = sampleSTD/plotCounter;
                        voltageSTD = Math.sqrt(sampleSTD);
                        sampleSTD = voltageSTD;
                        // make sure we can display codes
                        codeP2P = voltageP2P/LSBsize*gain;
                        codeMean = voltageMean/LSBsize*gain;
                        codeSTD = voltageSTD/LSBsize*gain;
                    }
                    // else already sampled as codes
                    else {
                        sampleMax = -32768;
                        sampleMin = 32768;
                        for(i=0;i<plotCounter;i++){
                            sampleMean += sampleArray[i];
                            if(sampleMax<sampleArray[i]) sampleMax = sampleArray[i];
                            if(sampleMin>sampleArray[i]) sampleMin = sampleArray[i];
                        }
                        sampleMean = sampleMean/plotCounter;
                        for(i=0;i<plotCounter;i++){
                            sampleSTD += Math.pow((sampleArray[i] - sampleMean),2);
                        }
                        codeP2P = sampleMax - sampleMin;
                        sampleP2P = codeP2P;
                        codeMean = sampleMean;
                        sampleSTD = sampleSTD/plotCounter;
                        codeSTD = Math.sqrt(sampleSTD);
                        sampleSTD = codeSTD;
                        // make sure we can display volts
                        voltageP2P = codeP2P*LSBsize/gain;
                        voltageMean = codeMean*LSBsize/gain;
                        voltageSTD = codeSTD*LSBsize/gain;
                    }
                    
                    if(chartValue===1){
                        templateObj.$.ti_widget_textbox3.setText(sampleMean.toFixed(6));
                        templateObj.$.ti_widget_textbox4.setText(sampleSTD.toFixed(6));
                        templateObj.$.ti_widget_textbox5.setText(sampleP2P.toFixed(6));
                    }
                    else {
                        templateObj.$.ti_widget_textbox3.setText(sampleMean.toFixed(2));
                        templateObj.$.ti_widget_textbox4.setText(sampleSTD.toFixed(2));
                        templateObj.$.ti_widget_textbox5.setText(sampleP2P.toFixed(2));
                    }
                    
                    if(chartValue===1){
                        if((Math.log(2*refVoltage/gain/sampleSTD)/Math.log(2))>16){
                            templateObj.$.ti_widget_textbox6.setText(16);
                        }
                        else{
                            templateObj.$.ti_widget_textbox6.setText((Math.log(2*refVoltage/gain/sampleSTD)/Math.log(2)).toFixed(2));
                        }
                        if((Math.log(2*refVoltage/gain/sampleP2P)/Math.log(2))>16){
                            templateObj.$.ti_widget_textbox7.setText(16);
                        }
                        else{
                            templateObj.$.ti_widget_textbox7.setText((Math.log(2*refVoltage/gain/(sampleP2P))/Math.log(2)).toFixed(2)); 
                        }
                    }
                    else {
                        if((Math.log(65535/(Math.sqrt(sampleSTD)))/Math.log(2))>16){
                            templateObj.$.ti_widget_textbox6.setText(16);
                        }
                        else {
                                templateObj.$.ti_widget_textbox6.setText((Math.log(65535/sampleSTD)/Math.log(2)).toFixed(2));
                        }
                        if((Math.log(65535/(Math.sqrt(sampleP2P)))/Math.log(2))>16){
                            templateObj.$.ti_widget_textbox7.setText(16);
                        }
                        else {
                            templateObj.$.ti_widget_textbox7.setText((Math.log(65535/(sampleP2P))/Math.log(2)).toFixed(2));
                        }
                    }
                }
            });
            
            
            templateObj.$.ti_widget_droplist2.addEventListener('selected', function(event) {
                var detailsObj = event.currentTarget;
                if(detailsObj.__data__.selectedValue===1) {
                    console.log('voltage chart');
                    if(chartValue===2) {
                        for(i=0;i<plotCounter;i++){
                            sampleArray[i] = sampleArray[i] * LSBsize / gain;
                        }
                    }
                    chartValue = 1;
                    chart.yAxisUnits = 'V';
                    chart.series_0_label = "Volts (V)";
                    chart.series_0_units = "V";
                    sampleMean = voltageMean;
                    sampleSTD = voltageSTD;
                    sampleP2P = voltageP2P;
                    templateObj.$.ti_widget_textbox3.setText(sampleMean.toFixed(6));
                    templateObj.$.ti_widget_textbox4.setText(sampleSTD.toFixed(6));
                    templateObj.$.ti_widget_textbox5.setText(sampleP2P.toFixed(6));
                }
                else {
                    console.log('code chart');
                    if(chartValue===1) {
                        for(i=0;i<plotCounter;i++){
                            sampleArray[i] = sampleArray[i] / LSBsize * gain;
                        }
                    }
                    chartValue = 2;
                    chart.yAxisUnits = 'Codes';
                    chart.series_0_label = "Codes ( d)";
                    chart.series_0_units = "Codes";
                    sampleMean = codeMean;
                    sampleSTD = codeSTD;
                    sampleP2P = codeP2P
                    templateObj.$.ti_widget_textbox3.setText(sampleMean.toFixed(2));
                    templateObj.$.ti_widget_textbox4.setText(sampleSTD.toFixed(2));
                    templateObj.$.ti_widget_textbox5.setText(sampleP2P.toFixed(2));
                }
            });
            
            
            templateObj.$.ti_widget_numberbox1.addEventListener('changed', function(event) {
                var detailsObj = event.currentTarget;
                refVoltage = detailsObj.__data__.value;
                LSBsize = refVoltage / (Math.pow(2,15));
                console.log(refVoltage);
                    
                    
            });
            
            
            // Expand vtabcontainer nav bar when user clicks on menu icon or 'Menu' label
            templateObj.toggleMenu = function(event){
                templateObj.$.ti_widget_vtabcontainer.isExpanded = !templateObj.$.ti_widget_vtabcontainer.isExpanded;
            };
            templateObj.$.ti_widget_icon_button_menu.addEventListener('click',templateObj.toggleMenu);
            templateObj.$.ti_widget_label_menu.addEventListener('click',templateObj.toggleMenu);

            if (templateObj.$.ti_widget_register_page) {
                // get the active device name from the register page
                templateObj.$.ti_widget_menubar.productName = templateObj.$.ti_widget_register_page.deviceName;

                // called when the user clicks the Write Register button:
                templateObj.$.ti_widget_register_page.addEventListener("write_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read Register button:
                templateObj.$.ti_widget_register_page.addEventListener("read_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read All Registers button:
                templateObj.$.ti_widget_register_page.addEventListener("read_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user changes the immediate / deferred mode
                templateObj.$.ti_widget_register_page.addEventListener("update_mode_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change update mode to " + detailsObj.mode.label);
                }.bind(this));

                // called when the user changes the auto read refresh rate
                templateObj.$.ti_widget_register_page.addEventListener("auto_read_config_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change automatic read interval to " + detailsObj.autoRead.label);
                }.bind(this));
                
                // called when the value of the register changes
                templateObj.$.ti_widget_register_page.addEventListener("reg_value_changed", function (event) {
                    var detailsObj = event.detail;
                    if(Number(detailsObj.regValue) & 0x10){
                        templateObj.$.ti_widget_eventlog_view.log("info", "register value changed: gain = 4" );
                        gain = 4;
                    }
                    else {
                        templateObj.$.ti_widget_eventlog_view.log("info", "register value changed: gain = 1 ");
                        gain = 1;
                    }
                    if(Number(detailsObj.regValue) & 0x02){
                        templateObj.$.ti_widget_eventlog_view.log("info", "register value changed: continuous conversion mmode" );
                        convertMode = 1;
                    }
                    else {
                        templateObj.$.ti_widget_eventlog_view.log("info", "register value changed: single-shot conversion mode");
                        convertMode = 0;
                    }
                }.bind(this));
            }

            var usbHidService = gc.services['ti-service-usbhid'];
            if (usbHidService) {
                usbHidService.addEventListener('usbHidError', function(event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify("error", detailsObj.info + ": " + detailsObj.error, false, true);
                })
            }

            templateObj.getRegisterData = function() {
                var regData = {
                    signature: "oneui-register-data",
                    data: []
                }
                var regBlocks = templateObj.$.ti_widget_register_page.regBlocks;
                for (var i = 0; i < regBlocks.length; i++) {
                    var registersData = [];
                    for (var r = 0; r < regBlocks[i].registers.length; r++) {
                        var reg = regBlocks[i].registers[r];
                        var regName = reg.name.toLowerCase();
                        regName = regName.replace(/\&/g, "_");
                        var item = {
                            idx: r,
                            id: regName,
                            value: reg.value
                        }
                        registersData.push(item);
                    }
                    regData.data.push(registersData);
                }
                var strJson = JSON.stringify(regData);
                return strJson;
            };

            templateObj.setRegisterData = function(strJson) {
                var regData = JSON.parse(strJson);
                var ok = true;
                var regBlocks = templateObj.$.ti_widget_register_page.regBlocks;
                for (var b = 0; b < regBlocks.length; b++) {
                    var registersData = [];
                    for (var r = 0; r < regBlocks[b].registers.length; r++) {
                        var reg = regBlocks[b].registers[r];
                        var regName = reg.name.toLowerCase();
                        regName = regName.replace(/\&/g, "_");
                        item = regData.data[b][r];
                        if (item.id === regName) {
                            reg.value = item.value;
                            var intValue = gc.utils.getValueFromHexString(""+reg.value);
                            templateObj.$.ti_widget_register_page.writeValueToTargetRegister(intValue, null, b, r);
                        } else {
                            var msg = "load registers failed: register name mismatch (" + item.id + " does not match " + regName + ")";
                            templateObj.logMsgAndNotify("warning", msg, false, true);
                        }
                    }

                }
            };

            templateObj.showToastMsg = function(msgType, msg, durationInSeconds) {
                templateObj.$.ti_widget_toast.hideToast();
                templateObj.$.ti_widget_toast.message = msg;
                switch (msgType.toLowerCase()) {
                    case "error":
                        templateObj.$.ti_widget_toast.iconName = "error";
                        templateObj.$.ti_widget_toast.backgroundColor = "red";
                        break;
                    case "warning":
                        templateObj.$.ti_widget_toast.iconName = "warning";
                        templateObj.$.ti_widget_toast.backgroundColor = "orange";
                        break;
                    default:
                        templateObj.$.ti_widget_toast.iconName = "check";
                        templateObj.$.ti_widget_toast.backgroundColor = "teal";
                        break;
                }
                templateObj.$.ti_widget_toast.duration = +durationInSeconds;
                templateObj.$.ti_widget_toast.showToast();
                console.log("toast msg [" + msgType + "]: " + msg);
            };

            templateObj.logMsgAndNotify = function(msgType, msg, showInStatusBar, showInToast) {
                var iconName = templateObj.$.ti_widget_eventlog_view.iconForItem(msgType);
                if (showInStatusBar) {
                    var statusBar = gc.services['ti-widget-statusbar'];
                    if (statusBar) {
                        statusBar.statusString3 = msg;
                        statusBar.setIcon(iconName);
                    }
                }
                if (showInToast) {
                    templateObj.showToastMsg(msgType, msg, 4);
                }
                templateObj.$.ti_widget_eventlog_view.log(msgType, msg);
            };
            templateObj.$.ti_widget_label_learnmore.addEventListener("click",function(event){
                 templateObj.$.ti_widget_label_productname.fontColor="#444";
                 templateObj.$.ti_widget_label_productdesc.fontColor="#444";
                 templateObj.$.ti_widget_label_learnmore.setAttribute('hidden',true);
                 templateObj.$.ti_widget_label_showless.removeAttribute('hidden');
                 templateObj.$.ti_widget_vtab_home.style.backgroundColor = "white";
                 templateObj.$.ti_widget_tabcontainer.selectedIndex = 1;
            });
            templateObj.$.ti_widget_label_showless.addEventListener("click",function(event){
                 templateObj.$.ti_widget_label_productname.fontColor="white";
                 templateObj.$.ti_widget_label_productdesc.fontColor="white";
                 templateObj.$.ti_widget_label_learnmore.removeAttribute('hidden');
                 templateObj.$.ti_widget_label_showless.setAttribute('hidden',true);
                 templateObj.$.ti_widget_vtab_home.style.backgroundColor = "rgb(20, 140, 156)";
                 templateObj.$.ti_widget_tabcontainer.selectedIndex = 0;
            });
	    if (templateObj.$.ti_widget_button_connect) {
                templateObj.$.ti_widget_button_connect.addEventListener("click",function(event){
                    if (gc.connectionManager){
                        gc.connectionManager.connect();
                    }
                });
	    }
            

        }, 1);

    });
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
    onChartReady();
} else {
    document.addEventListener('DOMContentLoaded', init);
}

var autoDetectDefers = [];
var _autoDetectPortIdentity = function(port, helperAPI) {
	return helperAPI.serialPortConnect().then(function() {
		var controllerName = "aevm";
		var configurationName = "i2c";
		var deviceName = "AEVM1119";
		var myDeviceName = null;

		var aevm = helperAPI.createPacketCodec(controllerName);
		var model = document.querySelector('ti-model-register');
		
		return model.getConfigurationSettings(deviceName, controllerName, configurationName).then(function(settings) {
			settings = [settings]
			console.log("opening: " + port.comName);
			return aevm.connect(settings).then(function() {
				return aevm.readValue({
					size: 1224,
					addr: 0x00,
					deviceAddrs: 0x51
				});
			}).then(function(deviceId) {
				myDeviceName = "AEVM1119";
			});
			
		}).fail(function(error) {
			console.log("failed to open port: " + error);	
			
		}).finally(function() { 
			aevm.disconnect();					
			console.log("closing: " + port.comName);
			return helperAPI.serialPortDisconnect().then(function() {
				autoDetectDefers.shift().deferred.resolve(myDeviceName);
			});
		});
	}).finally(function() {
		if (autoDetectDefers.length > 0) {
			_autoDetectPortIdentity(autoDetectDefers[0].port, autoDetectDefers[0].helperAPI);
		}
	});
};
	
gc.autoDetectPortIdentity = function(port, helperAPI)
{
	var deferred = Q.defer();
	var start = autoDetectDefers.length == 0;
		
	autoDetectDefers.push({deferred: deferred, port: port, helperAPI: helperAPI});
	if (start) {
		_autoDetectPortIdentity(port, helperAPI);
	}
	
	return deferred.promise;
	
	
	return helperAPI.serialPortConnect().then(function()  
		{
			var controllerName = "aevm";
			var configurationName = "i2c";

			var aevm = helperAPI.createPacketCodec(controllerName);
			
			var model = document.querySelector('ti-model-register');

			var deviceName = "AEVM1119";
			return model.getConfigurationSettings(deviceName, controllerName, configurationName).then(function(settings) 
			{
				settings = [settings]
				console.log(port.comName);
				return aevm.connect(settings).then(function() 
				{
					return aevm.readValue(
					{
						size: 1224,
						addr: 0x00,
						deviceAddrs: 0x51
					});
				}).then(function(deviceId) 
				{
					return deviceName;
				}); 
			}).finally(function() 
			{ 
				aevm.disconnect();
				return helperAPI.serialPortDisconnect();
			});
		});
	
}
            
gc.autoDetectPortsFilter = function(transport, ports, info) 
{
    return ports;
};

